"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var AuthScope = /** @class */ (function () {
    function AuthScope(scope) {
        if (scope === void 0) { scope = {}; }
        this.SCOPE = __assign({ read: 'r', write: 'w' }, scope);
        this.REVERSE_SCOPE = Object.entries(this.SCOPE).reduce(function (obj, _a) {
            var k = _a[0], v = _a[1];
            return (__assign({}, obj, (_b = {}, _b[v] = k, _b)));
            var _b;
        }, {});
    }
    /**
     * Returns a scope in the format 'a:r:w' using a set of rules like
     * ['admin:read', 'admin:write']
     */
    AuthScope.prototype.create = function (scope) {
        var _this = this;
        if (!scope.length)
            return '';
        var lastName;
        var shortPerm = function (perm) { return _this.SCOPE[perm] || perm; };
        var shortRole = function (newScope, r) {
            var role = r.split(':').map(shortPerm);
            if (lastName === role[0]) {
                newScope[newScope.length - 1] += ":" + role.slice(1).join(':');
                return newScope;
            }
            lastName = role[0];
            newScope.push(role.join(':'));
            return newScope;
        };
        var scopeStr = scope.reduce(shortRole, []).join('|');
        return scopeStr;
    };
    /**
     * Returns a scope string as an array of rules
     */
    AuthScope.prototype.parse = function (scopeStr) {
        var _this = this;
        if (!scopeStr)
            return [];
        var longPerm = function (perm) { return _this.REVERSE_SCOPE[perm] || perm; };
        var joinPerm = function (name) { return function (perm) { return name + ':' + perm; }; };
        var splitRole = function (role) {
            var _a = role.split(':').map(longPerm), name = _a[0], perms = _a.slice(1);
            return perms.map(joinPerm(name));
        };
        var pushRoles = function (roles, role) {
            return roles.concat(splitRole(role));
        };
        return scopeStr.split('|').reduce(pushRoles, []);
    };
    return AuthScope;
}());
exports.default = AuthScope;
//# sourceMappingURL=scope.js.map