"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var payload_1 = require("../payload");
describe('Auth Payload', function () {
    var payload = new payload_1.default({
        uId: 'id',
        cId: 'companyId',
        scope: 'scope'
    });
    var user = {
        id: 'user_123',
        companyId: 'company_123',
        scope: 'a:r:w'
    };
    var reverseUser = {
        uId: 'user_123',
        cId: 'company_123',
        scope: 'a:r:w'
    };
    var randomKeys = {
        name: 'Luis',
        lastName: 'Alvarez'
    };
    it('Has a proper check for empty values', function () {
        expect(payload_1.isEmpty(null)).toBe(true);
        expect(payload_1.isEmpty(undefined)).toBe(true);
        expect(payload_1.isEmpty({})).toBe(true);
        expect(payload_1.isEmpty([])).toBe(true);
        expect(payload_1.isEmpty(' ')).toBe(true);
        expect(payload_1.isEmpty('something')).toBe(false);
        expect(payload_1.isEmpty(0)).toBe(false);
        expect(payload_1.isEmpty(false)).toBe(false);
        expect(payload_1.isEmpty([0])).toBe(false);
        expect(payload_1.isEmpty({ '0': 0 })).toBe(false);
    });
    it('Creates a payload', function () {
        expect(payload.create({})).toEqual({});
        expect(payload.create(__assign({}, randomKeys, user))).toEqual(reverseUser);
    });
    it('Parses a payload', function () {
        expect(payload.parse({})).toEqual({});
        expect(payload.parse(__assign({}, randomKeys, reverseUser))).toEqual(user);
    });
    it('Always returns the same object with empty call to constructor', function () {
        var empty = new payload_1.default();
        expect(empty.create(user)).toEqual(user);
        expect(empty.parse(reverseUser)).toEqual(reverseUser);
    });
});
//# sourceMappingURL=payload.js.map