"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEmpty = function (value) {
    return value === undefined ||
        value === null ||
        (typeof value === 'object' && Object.keys(value).length === 0) ||
        (typeof value === 'string' && value.trim().length === 0);
};
var AuthPayload = /** @class */ (function () {
    function AuthPayload(payload) {
        if (payload === void 0) { payload = {}; }
        this.PAYLOAD = Object.entries(payload);
        this.REVERSE_PAYLOAD = this.PAYLOAD.map(function (_a) {
            var pk = _a[0], k = _a[1];
            return [k, pk];
        });
    }
    /**
     * Replaces the keys of a payload
     */
    AuthPayload.prototype.reverse = function (keys, payload) {
        if (!keys.length)
            return payload;
        return keys.reduce(function (p, _a) {
            var k = _a[0], pk = _a[1];
            var v = payload[k];
            if (!exports.isEmpty(v))
                p[pk] = v;
            return p;
        }, {});
    };
    AuthPayload.prototype.create = function (payload) {
        return this.reverse(this.REVERSE_PAYLOAD, payload);
    };
    AuthPayload.prototype.parse = function (payload) {
        return this.reverse(this.PAYLOAD, payload);
    };
    return AuthPayload;
}());
exports.default = AuthPayload;
//# sourceMappingURL=payload.js.map